//+------------------------------------------------------------------+
//|                                              VolatilityPivot.mq5 |
//|                                         Copyright  2007, S.B.T. | 
//|                                     http://sufx.core.t3-ism.net/ | 
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2007, S.B.T."
//----    
#property link "http://sufx.core.t3-ism.net/"
//----   
#property version   "1.10"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 1
//----    
#property indicator_plots   1
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----        FireBrick 
#property indicator_color1  clrFireBrick
//----   1 -  
#property indicator_style1  STYLE_SOLID
//----    1  3
#property indicator_width1  3
//----    
#property indicator_label1  "VolatilityPivot"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+

//----    CXATR   SmoothAlgorithms.mqh
CXMA XATR1;
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method ima_Method=MODE_LWMA; //                   
input int           ima_Phase=15; // ,
                                  // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
input uint          ima_range=100;
input bool          Mode=false;
input double        atr_factor=3;
input double        DeltaPrice=30;
input int           Shift=0; //     
//+----------------------------------------------+
//----   ,    
//      
double IndBuffer[];
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=int(XATR1.GetStartBars(ima_Method,ima_range,ima_Phase)+1);

//----      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"VolatilityPivot");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----       
   double atr,DeltaStop;
//----        
   int first,bar;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=1; //      
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {

      if(!Mode)
        {
         atr=MathMax(high[bar],close[bar-1])-MathMin(low[bar],close[bar-1]);
         DeltaStop=XATR1.XMASeries(1,prev_calculated,rates_total,ima_Method,ima_Phase,ima_range,atr,bar,false);
         DeltaStop*=atr_factor;
        }
      else DeltaStop=DeltaPrice*_Point;

      if(close[bar]==IndBuffer[bar-1]) IndBuffer[bar]=IndBuffer[bar-1];
      else
        {
         if(close[bar-1]<IndBuffer[bar-1] && close[bar]<IndBuffer[bar-1]) IndBuffer[bar]=MathMin(IndBuffer[bar-1],close[bar]+DeltaStop);
         else
           {
            if(close[bar-1]>IndBuffer[bar-1] && close[bar]>IndBuffer[bar-1]) IndBuffer[bar]=MathMax(IndBuffer[bar-1],close[bar]-DeltaStop);
            else if(close[bar]>IndBuffer[bar-1]) IndBuffer[bar]=close[bar]-DeltaStop;
            else IndBuffer[bar]=close[bar]+DeltaStop;
           }
        }
     }
//----    
   return(rates_total);
  }
//+------------------------------------------------------------------+
